package com.adc.da.util.utils;

import org.dozer.Mapper;
import org.springframework.stereotype.Component;

import com.adc.da.util.http.PageInfo;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * ADC源代码，版权归北京卡达克数据技术中心所有。
 * User: rennver
 * Date: 2017/6/15
 * Time: 22:43
 * Description:封装Dozer进行复杂对象拷贝操作
 */
@Component("beanMapper")
public class BeanMapper {
    @Resource
    private Mapper dozer;

    public <T> T map(Object source, Class<T> destinationClass) {
        if (source == null) {
            return null;
        }
        return dozer.map(source, destinationClass);
    }
    public <T> List<T> mapList(Collection sourceList, Class<T> destinationClass) {
        List destinationList = new ArrayList();
        if (sourceList == null) {
            return destinationList;
        }
        for (Iterator i$ = sourceList.iterator(); i$.hasNext(); ) {
            Object sourceObject = i$.next();
            Object destinationObject = dozer.map(sourceObject, destinationClass);
            destinationList.add(destinationObject);
        }
        return destinationList;
    }
    public void copy(Object source, Object destinationObject) {
        dozer.map(source, destinationObject);
    }
    public <T> PageInfo<T> mapPage(PageInfo source, Class<T> destinationClass){
        PageInfo<T> pageInfo = new PageInfo<T>();
        pageInfo.setPageNo(source.getPageNo());
        pageInfo.setPageSize(source.getPageSize());
        pageInfo.setCount(source.getCount());
        pageInfo.setPageCount(source.getPageCount());
        return pageInfo.setList(mapList(source.getList(), destinationClass));
    }
}